; 1K Frequency Table.
; Fred Quimby, Darrell Spice Jr, Chris Walton 2010
;
; The 1K Frequency Table can contain up to 256 frequency values
;
; Table entries are defined as 2^32*freq/20000
;
; If User ARM code is being used, then the last 512 bytes of the frequency
; table will no longer be available, reducing the number of frequencies you can
; use to 128.


; For Draconian, the full 1K Frequency Table RAM space has been allocated for
; the C code.  This is done by changing the RAM line in file
;   custom/src/custom.boot.lds


	if (* <= $1400)
	  echo "------",($1400 - *) , "bytes of Frequency Data left"
	  echo "        room for ", [($1400 - *)/4]d, " frequencies"
	  echo " NOTE: if you are using User ARM Code, these are reduced to:"
	  echo "------",($1200 - *) , "bytes of Frequency Data left"
	  echo "        room for ", [($1200 - *)/4]d, " frequencies"
	  ds ($1400-*) ; pad out remaining space in frequency table
	else
	  echo "FATAL ERROR - Frequency table exceeds 1K"
	  err
	endif
