# 1 "main.c"
# 1 "/home/darrell/Desktop/Parallels Shared Folders/Home/Projects/Atari/Draconian/custom//"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "main.c"
# 30 "main.c"
# 1 "src/custom.h" 1
extern unsigned char * const queue;
extern unsigned char * const flashdata;
# 31 "main.c" 2
# 59 "main.c"
# 1 "defines.h" 1
# 60 "main.c" 2
unsigned char * const queue=(unsigned char *)0x40000C00;
unsigned char * const flashdata=(unsigned char *)0x0C00;
unsigned char * const ddrom=(unsigned char *)0x6C00;

int * const queue_int=(int *)0x40000C00;


unsigned char * const gP0DataStream =(unsigned char *)(0x40000C00 + 322);
unsigned char * const gP1DataStream =(unsigned char *)(0x40000C00 + 503);
unsigned char * const gMissileBallDataStream =(unsigned char *)(0x40000C00 + 684);
unsigned char * const gHMP0DataStream =(unsigned char *)(0x40000C00 + 844);
unsigned char * const gHMP1DataStream =(unsigned char *)(0x40000C00 + 1004);
unsigned char * const gColorHMDataStream =(unsigned char *)(0x40000C00 + 1164);
unsigned char * const gSizeBallColorDataStream =(unsigned char *)(0x40000C00 + 1324);
unsigned short int * const gJumpDataStream =(unsigned short int *)(0x40000C00 + 0);


unsigned short int * const gMenuOptionsDatastream =(unsigned short int *)(0x40000C00 + 1488);
unsigned char * const gMenuColors =(unsigned char *)(0x40000C00 + 1548);


unsigned char gStationState[8];
unsigned char gSpriteState[150];
unsigned char gSpriteImageID[150 +1];
unsigned short int gSpriteX[150 +1];
unsigned short int gSpriteY[150 +1];
unsigned char gSpriteColor[150];
unsigned char * const gStationImages =(unsigned char *)(0x40000C00 + 1764);

unsigned char gSpriteFlickerList1[150];
unsigned char gSpriteFlickerList2[150];
static unsigned char* gNonFlickeredSprites;

unsigned char gShotState[20 +1];
unsigned char gShotX[20 +1];
unsigned char gShotY[20 +1];
unsigned char gShotFlickerList1[20];
unsigned char gShotFlickerList2[20];
static unsigned char* gNonFlickeredShots;


short int *gImageGraphics =(short int *)(0x0C00 + 18542);
short int *gImageShift =(short int *)(0x0C00 + 18608);
unsigned char *gImageHeight =(unsigned char *)(0x0C00 + 18612);
unsigned char * const gObjectColors =(unsigned char *)(0x40000C00 + 2288);


unsigned char * const gPlayfield =(unsigned char *)(0x40000C00 + 1644);

int gScore;
int gLevel;

short int gStarfieldXoffset;
short int gStarfieldYoffset;
unsigned char gStarfieldTopStar;
unsigned char gReserveLives;
unsigned char gCondition;

unsigned short int gWindowX;
unsigned short int gWindowY;
int gShipDir;
int gFormationSize;

unsigned char gGunCoolDown;
unsigned char gInitLevel;




int Collision(int image1_id, int left1, int top1, int sprite_index);
int ColorConvert(int color);
int DataStream(int stream, int index, int lumaboost);
int DataStreamShot(int stream, int index, int firstcall);
void DeathSequences();
void DisplayShots();
void DisplaySprites();
void DisplayStars();
void FixSizes();
void IncreaseScore(int points);
void InitDatastreams();
void InitDeathSequence(int index, int not_deadly);
void Initialize();
void InitLevel();
void MoveFormation();
void MoveShots();
void my_memcpy(unsigned char* destination, unsigned char* source, int count);
void my_memset(unsigned char* destination, int fill_value, int count);
void NewGame();
void OverScan();
void OverScanMenu();
void PodHit(int station, int pod);
void PrepScoreRadar();
void ProcessJoystick();
void ProcessMenuJoystick();
void ProcessSwitches();
unsigned int Random32();
void ShipCollisions();
void ShotCollisions();
void StationShots();
void PrepStationGraphics();
void TriggerSoundEffect(int SoundID);
void UpdateSound();
void VerticalBlank();
void VerticalBlankMenu();


const unsigned char shot_height[] =
{
    1,
    2,
    5,
    3,
    3,
    7,
    7,
    13
};
const unsigned char shot_size[] =
{
    0x20,
    0x10,
    0x00,
    0x10,
    0x30,
    0x20,
    0x20,
    0x10
};






const unsigned char pod_offset_x[] =
{
    10,
    20,
    20,
    10,
     0,
     0,
    10,
     6,
    18,
    24,
    18,
     6,
     0,
    12
};

const unsigned char pod_offset_y[] =
{
     0,
    13,
    37,
    50,
    37,
    13,
    28,
     0,
     0,
    21,
    42,
    42,
    21,
    22
};

const unsigned char pod_shape[] =
{
    30,
    30,
    30,
    30,
    30,
    30,
    31,
    30,
    30,
    30,
    30,
    30,
    30,
    32
};

int main()
{
    *(unsigned char*)0xE01FC000=1;

    switch ((*(unsigned char *)(0x40000C00 + 2699 )))
    {
        case 0: Initialize(); break;
        case 1: OverScan(); break;
        case 2: VerticalBlank(); break;
        case 3: OverScanMenu(); break;
        case 4: VerticalBlankMenu(); break;
        case 5: InitLevel(); break;
    }

    *(unsigned char*)0xE01FC000=2;

    return 0;
}

void my_memset(unsigned char* destination, int fill_value, int count)
{
    int i;
    for (i=0;i<count;i++)
        destination[i]=fill_value;
}

void my_memcpy(unsigned char* destination, unsigned char* source, int count)
{
    int i;
    for(i=0;i<count;i++)
        destination[i] = source[i];
}

void Initialize()
{
}


void OverScan()
{
    ProcessSwitches();
    if ((*(unsigned char *)(0x40000C00 + 2705 )) != 0)
    {
        DeathSequences();
        ShotCollisions();
        ShipCollisions();
        ProcessJoystick();
        StationShots();
        MoveShots();
        MoveFormation();
        PrepStationGraphics();
        PrepScoreRadar();
    }
    UpdateSound();
}


void VerticalBlank()
{
    InitDatastreams();
    if (gInitLevel)
    {
        gJumpDataStream[0] = 65395;
        PrepScoreRadar();
    }
    else
    {
        DisplaySprites();
        DisplayShots();
        FixSizes();
        DisplayStars();
    }
    gP0DataStream[160] = gP1DataStream[160] = 0;
}


void OverScanMenu()
{
    ProcessSwitches();
    if ((*(unsigned char *)(0x40000C00 + 2705 )) == 0)
    {
        ProcessMenuJoystick();
    }
    UpdateSound();
}

void VerticalBlankMenu()
{
    int i;
    int ones;
    int tens;
    int hundreds;
    int thousands;



    my_memcpy((unsigned char *)queue + 0,
              (unsigned char *)ddrom + 0,
              1724);


    for(i=0;i<176;i++)
        gMenuColors[i] = ColorConvert(gMenuColors[i]);



    for(i=-2;i<11;i++)
        queue[2288 + i] = ColorConvert(ddrom[2288 +i]);


    thousands = 0;
    hundreds = 0;
    tens = 0;
    ones = (*(unsigned char *)(0x40000C00 + 2715 ))+1;

    while (ones >= 1000)
    {
        thousands++;
        ones -= 1000;
    }
    while (ones >= 100)
    {
        hundreds++;
        ones -= 100;
    }
    while (ones >= 10)
    {
        tens++;
        ones -= 10;
    }
    if (thousands == 0)
    {
        thousands = 10;
        if (hundreds == 0)
        {
            hundreds = 10;
            if (tens == 0)
                tens = 10;
        }
    }

    for(i=0;i<8;i++)
    {
        ((unsigned char *)(0x40000C00 + 1346 ))[i] = (((unsigned char *)(0x0C00 + 25922 ))[i + thousands*8] << 4) + ((unsigned char *)(0x0C00 + 25922 ))[i + hundreds*8];
        ((unsigned char *)(0x40000C00 + 1354 ))[i] = (((unsigned char *)(0x0C00 + 25922 ))[i + tens*8] << 4) + ((unsigned char *)(0x0C00 + 25922 ))[i + ones*8];
    }


    switch ((*(unsigned char *)(0x40000C00 + 2716 )))
    {
        case 1: gMenuOptionsDatastream[1*10 + 0] = 1258;
            gMenuOptionsDatastream[1*10 + 1] = 1250;
            break;
        case 2: gMenuOptionsDatastream[1*10 + 0] = 1282;
            gMenuOptionsDatastream[1*10 + 1] = 1274;
            gMenuOptionsDatastream[1*10 + 2] = 1266;
            break;
    }


    for(i=0;i<16;i+=2)
    {







        queue[1688 + i+1] = (*(unsigned char *)(0x40000C00 + 2693 ));
        queue[1688 + i+0] = queue[gMenuOptionsDatastream[(*(unsigned char *)(0x40000C00 + 2714 ))*10 + 6] + i];
    }
    gMenuOptionsDatastream[(*(unsigned char *)(0x40000C00 + 2714 ))*10 + 6] = 1688;
}

void ProcessSwitches()
{
    (*(unsigned char *)(0x40000C00 + 2693 ))++;
    Random32();
    if (!((*(unsigned char *)(0x40000C00 + 2701 )) & 2)) (*(unsigned char *)(0x40000C00 + 2705 )) = 0;
    else if (!((*(unsigned char *)(0x40000C00 + 2701 )) & 1)) NewGame();
}



void NewGame()
{
    (*(unsigned char *)(0x40000C00 + 2705 )) = 1;
    gScore = 0;
    gReserveLives = 3;
    gCondition = 0;
    gGunCoolDown = 0;

    gLevel = (*(unsigned char *)(0x40000C00 + 2715 ));


    gInitLevel = 1;
}
# 465 "main.c"
const unsigned short int level1[] =
{
    256, 512,
    8,
    0 + 20, 8,
    1024 + 84, 72,
    0 + 148, 136,
    1024 + 212, 200,
    0 + 276, 264,
    1024 + 340, 328,
    0 + 404, 392,
    1024 + 468, 460
};

const unsigned short int level2[] =
{
    256, 768,
    8,
    1024 + 480, 60,
    0 +420, 120,
    1024 + 360, 180,
    0 +300, 240,
    1024 + 240, 300,
    0 +180, 360,
    1024 + 120, 420,
    0 + 60, 480
};

const unsigned short int level3[] =
{
    256, 256,
    8,
    1024 + 60, 120,
    0 +120, 60,
    1024 +480, 120,
    0 +420, 60,

    1024 + 60, 840,
    0 +120, 900,
    1024 +480, 840,
    0 +420, 900
};

const unsigned short int level4[] =
{
    256, 768,
    8,
    0 + 60, 512,
    0 + 120, 512,
    0 + 180, 512,
    0 + 240, 512,
    0 + 300, 512,
    0 + 360, 512,
    0 + 420, 512,
    0 + 480, 512
};

const unsigned short int level5[] =
{
    256, 768,
    8,
    1024 + 60, 512,
    1024 + 120, 512,
    1024 + 180, 512,
    1024 + 240, 512,
    1024 + 300, 512,
    1024 + 360, 512,
    1024 + 420, 512,
    1024 + 480, 512
};

const unsigned short int level6[] =
{
    256, 512,
    6,
    1024 + 240, 410,
    1024 + 240, 560,
    0 + 176, 450,
    0 + 176, 520,
    0 + 304, 450,
    0 + 304, 520
};

const unsigned short int * levels[] =
{
    level1,
    level2,
    level3,
    level4,
    level5,
    level6
};

void InitLevel()
{
    int i;
    int s;
    int l;
    int x;
    int y;
    int a;
    int c;
    int d;
    const unsigned short int *level;


    level = levels[gLevel];

    gInitLevel = 0;

    gNonFlickeredSprites = 0;
    for (i=0;i<150;i++)
    {
        gSpriteState[i] = 0;
        gSpriteFlickerList1[i] = i;
    }

    gNonFlickeredShots = 0;
    for (i=0;i<20;i++)
    {
        gShotState[i] = 0;
        gShotFlickerList1[i] = i;
    }


    gStarfieldXoffset = 0;
    gStarfieldYoffset = 0;
    gStarfieldTopStar = 0;
    for (i=0;i<128;i++)
    {
        ((unsigned char *)(0x40000C00 + 2299 ))[i] = (160 * (Random32() & 0xff)) >> 8;
        ((unsigned char *)(0x40000C00 + 2427 ))[i] = ((Random32() & 0x300) >> 8) + 2;
        if ((*(unsigned char *)(0x40000C00 + 2716 )) == 2)
            ((unsigned char *)(0x40000C00 + 2555 ))[i] = ((14 * (Random32() & 0xff)) >> 8) + 2;
        else
            ((unsigned char *)(0x40000C00 + 2555 ))[i] = ((Random32() & 0xF700) >> 8) + 0x08;
    }


    l = 0;
    gSpriteState[8] = 0x80;
    gSpriteImageID[8] = 10;
    gSpriteColor[8] = gObjectColors[2];
    gSpriteX[8] = level[l++] << 7;
    gSpriteY[8] = level[l++] << 6;
    gShipDir = 0;

    gWindowX = gSpriteX[8] - (80 << 7);
    gWindowY = gSpriteY[8] - (((160 - 16) /2) << 6);


    for(i=0;i<8;i++)
        gStationState[i] = 0;


    my_memset(gStationImages, 0, 65*8);
    s = level[l++];
    for (i=0;i<s;i++)
    {
        gSpriteState[i] = 0x80;
        gStationState[i] = 0x3F;
        gSpriteImageID[i] = 0 + (level[l] >> 10);
        gSpriteColor[i] = gObjectColors[7];
        gSpriteX[i] = (level[l++] & 511) << 7;
        gSpriteY[i] = level[l++] << 6;
        my_memcpy((unsigned char *)queue + 1764 + i*65,
                  (unsigned char *)flashdata + gImageGraphics[gSpriteImageID[i]],
                  gImageHeight[gSpriteImageID[i]]);
    }


    a = 22;
    d = 4;
    for (l=0;l<32;l++)

    {
        for (i=0; i < d; i++)
        {
            do
            {
                x = (( 504 * (Random32() & 0xff)) >> 8) << 7;
                y = ((l * 32) + (Random32() & 15)) << 6;
                c = 0;




                if (y + (15 << 6) >= gSpriteY[8] - (25 << 6))
                    if (y <= gSpriteY[8] + ((25 + 17) << 6))
                        if (x + (8 << 7) >= gSpriteX[8] - (25 << 7))
                            if (x <= gSpriteX[8] + ((9 + 25) << 7))
                                c = 1;


                if (c == 0)
                    for (s=0;s<i;s++)
                    {
                        if (x + (8 << 7) >= gSpriteX[a+s])
                            if (x <= gSpriteX[a+s] + (8 << 7))
                                c = 1;
                    }


                if (c == 0)
                    for (s=0;s<8;s++)
                    {
                        if (gSpriteState[s])
                        {
                            if (y + (15 << 6) >= gSpriteY[s])
                                if (y <= gSpriteY[s] + (65 << 6))
                                    if (x + (8 << 7) >= gSpriteX[s])
                                        if (x <= gSpriteX[s] + (32 << 7))
                                            c = 1;
                        }
                    }
            } while (c);
            gSpriteState[a+i] = 0x80;
            gSpriteX[a+i] = x;
            gSpriteY[a+i] = y;
            gSpriteImageID[a+i] = (Random32() & 3) + 6;
            gSpriteColor[a+i] = (gSpriteImageID[a+i] == 9) ? gObjectColors[1] : gObjectColors[0];
        }
        a += d;
    }
# 699 "main.c"
    gFormationSize = 4;
    s = 18;
    for (i = 9; i< 9 + gFormationSize; i++)
    {
        gSpriteState[i] = 0x80;
        gSpriteX[i] = 156 << 7;
        gSpriteY[i] = (768 + i * 18) << 6;
        gSpriteImageID[i] = s;
        gSpriteColor[i] = (gSpriteImageID[i] == 18) ? gObjectColors[5] :
                              (gSpriteImageID[i] == 20) ? gObjectColors[3] :
                              (gSpriteImageID[i] == 22) ? gObjectColors[4] : gObjectColors[6];
        s += 2;
    }
# 731 "main.c"
}

void InitDatastreams()
{
    int i;

    my_memset((unsigned char *)queue + 322, 0, 160);
    my_memset((unsigned char *)queue + 844, 0, 160);
    my_memset((unsigned char *)queue + 503, 0, 160);
    my_memset((unsigned char *)queue + 1004, 0, 160);
    my_memset((unsigned char *)queue + 1164, 0, 160);
    my_memset((unsigned char *)queue + 1324, 0, 160);
    my_memset((unsigned char *)queue + 684, 0, 160);
    my_memset(((unsigned char *)(0x40000C00 + 1484 )), 0, 160);

    for(i=0;i<160;i++)
        gJumpDataStream[i] = 61896;
    gJumpDataStream[160 -1] = 61952;
}

unsigned int Random32()
{



    static unsigned int random = 0x02468ace;

    return random = (random >> 1) ^ (unsigned int)(-(random & 1u) & 0xd0000001u);
}

const unsigned char energy_offset_x[] =
{
    10,
    12,
    14,
    15
};

const unsigned char energy_offset_y[] =
{
    31,
    29,
    25,
    22
};

void DisplaySprites()
{
    int i;
    int sprite;
    int shown;
    unsigned char* sprite_shown_ptr;
    unsigned char* sprite_not_shown_ptr;
    int boost;
    int energy_shape;
    int x;
    int y;

    sprite_not_shown_ptr = gSpriteFlickerList1;
    sprite_shown_ptr = gSpriteFlickerList2;

    (*(unsigned char *)(0x40000C00 + 2687 )) = (*(unsigned char *)(0x40000C00 + 2686 )) = 0xff;
    (*(unsigned char *)(0x40000C00 + 2690 )) = (*(unsigned char *)(0x40000C00 + 2691 )) = 0x0f;
    (*(unsigned char *)(0x40000C00 + 2688 )) = (*(unsigned char *)(0x40000C00 + 2689 )) = 0;

    boost = ((*(unsigned char *)(0x40000C00 + 2716 )) == 2) ? 0 : 2;




    for (i=0;i<8;i++)
        gSpriteState[i] &= 0xbf;

    for (i=0;i<150;i++)
    {
        sprite = gSpriteFlickerList1[i];
        shown = 0;

        if (gSpriteState[sprite])
        {
            if (gNonFlickeredSprites == sprite_not_shown_ptr) boost = 0;
            if (DataStream(0, sprite, boost)) shown = 2;
            else if (DataStream(1, sprite, boost)) shown = 1;
        }
        if (shown)
        {
            *sprite_shown_ptr = sprite;
            sprite_shown_ptr++;
            if ((sprite < 8) && (gSpriteState[sprite] && 0x40))
            {
                if (gStationState[sprite] & 0x40)
                {

                    gStationState[sprite] ^= 0x80;
                    energy_shape = (gSpriteImageID[sprite] << 1) +
                                   ((gStationState[sprite] & 0x80) >> 7);

                    x = (((gSpriteX[sprite] - gWindowX) >> 7) & (512 -1)) + energy_offset_x[energy_shape];
                    y = (((gSpriteY[sprite] - gWindowY) >> 6) & (1024 -1)) + energy_offset_y[energy_shape];

                    energy_shape += 4;

                    if (x > (512 / 2)) x -= 512;
                    if (y > (1024 / 2)) y -= 1024;
                    if (x > 0 && x < 160 && y > -shot_height[energy_shape] && y < 160)
                    {
                        gShotX[20] = x;
                        gShotY[20] = y;
                        gShotState[20] = energy_shape ;
                        DataStreamShot(shown-1, 20, 1);
                    }
                }
            }
        }
        else
        {
            *sprite_not_shown_ptr = sprite;
            sprite_not_shown_ptr++;
        }
    }
    gNonFlickeredSprites = sprite_not_shown_ptr;
    my_memcpy(sprite_not_shown_ptr, gSpriteFlickerList2, sprite_shown_ptr-gSpriteFlickerList2);



    if ((*(unsigned char *)(0x40000C00 + 2687 )) == 0xff) (*(unsigned char *)(0x40000C00 + 2687 )) = 0;
    if ((*(unsigned char *)(0x40000C00 + 2686 )) == 0xff) (*(unsigned char *)(0x40000C00 + 2686 )) = 0;
}

void DisplayShots()
{
    int i;
    int shot;
    int shown;
    int ds0;
    int ds1;
    unsigned char* shot_shown_ptr;
    unsigned char* shot_not_shown_ptr;

    shot_not_shown_ptr = gShotFlickerList1;
    shot_shown_ptr = gShotFlickerList2;

    ds0 = (*(unsigned char *)(0x40000C00 + 2693 )) & 1;
    ds1 = 1 - ds0;

    (*(unsigned char *)(0x40000C00 + 2685 )) = (*(unsigned char *)(0x40000C00 + 2684 )) = 0xff;

    for (i=0;i<20;i++)
    {
        shot = gShotFlickerList1[i];
        shown = 0;

        if (gShotState[shot])
        {
            if (DataStreamShot(ds0, shot, 1)) shown = 1;
            else if (DataStreamShot(ds1, shot, 0)) shown = 1;
        }
        if (shown)
        {
            *shot_shown_ptr = shot;
            shot_shown_ptr++;
        }
        else
        {
            *shot_not_shown_ptr = shot;
            shot_not_shown_ptr++;
        }
    }
    gNonFlickeredShots = shot_not_shown_ptr;
    my_memcpy(shot_not_shown_ptr, gShotFlickerList2, shot_shown_ptr-gShotFlickerList2);



    if ((*(unsigned char *)(0x40000C00 + 2685 )) == 0xff) (*(unsigned char *)(0x40000C00 + 2685 )) = 0;
    if ((*(unsigned char *)(0x40000C00 + 2684 )) == 0xff) (*(unsigned char *)(0x40000C00 + 2684 )) = 0;
}
# 933 "main.c"
int DataStream(int stream, int index, int lumaboost)
{


    static int y;
    static int x;
    static int height;
    static int imageID;
    static int offset;
    static int size;
    static int width;

    int hmove;
    int position;
    int i;
    unsigned char * playerstream;
    unsigned char * hmpstream;
    unsigned short int * resptable;
    int mask;


    if (stream == 0)
    {
        imageID = gSpriteImageID[index];
        if (imageID <= 1)
        {
            size = 7;
            width = 32;
        }
        else if (imageID <= 5)
        {
            size = 5;
            width = 16;
        }
        else
        {
            size = 0;
            width = 8;
        }

        x = ((gSpriteX[index] - gWindowX) >> 7) & (512 -1);
        y = ((gSpriteY[index] - gWindowY) >> 6) & (1024 -1);

        if (x > (512 / 2)) x -= 512;
        if (y > (1024 / 2)) y -= 1024;

        if (x+width < 8) return 1;
        if (x > 159) return 1;

        height = gImageHeight[imageID];
        if (y < 0)
        {
            if (-y >= height)
                return 1;
            offset = -y;
            height -= offset;
            y = 0;
        }
        else if (y >= 160)
            return 1;
        else
            offset = 0;

        if (y+height >= 160)
            height = 160 - y;


        if (index < 8)
            gSpriteState[index] |= 0x40;


        playerstream = gP0DataStream;
        hmpstream = gHMP0DataStream;
        resptable = ((unsigned short int *)(0x0C00 + 18432 ));
    }
    else
    {

        playerstream = gP1DataStream;
        hmpstream = gHMP1DataStream;
        resptable = ((unsigned short int *)(0x0C00 + 18454 ));
    }

    if (y < 4)
    {


        if (((unsigned char *)(0x40000C00 + 2686 ))[1-stream] != 0xff)
            return 0;
        position = 0;
    }
    else
    {



        if (gJumpDataStream[y-1] == 61896) position = -1;
        else if (gJumpDataStream[y-2] == 61896) position = -2;

        else if (gJumpDataStream[y-3] == 61896) position = -3;
        else if (gJumpDataStream[y-4] == 61896) position = -4;
        else return 0;
    }


    for (i = (y + position); i < (y + height) && i < 160;i++)
    {
        if (hmpstream[i] != 0)
            return 0;
    }


    if (index < 8)
    {

        my_memcpy(playerstream + y,
                  (unsigned char *)queue + 1764 + index*65 + offset,
                  height);
    }
    else
    {

        my_memcpy(playerstream + y,
                  (unsigned char *)flashdata + gImageGraphics[imageID] + offset,
                  height);
    }


    if (width != 8)
    {
        mask = 0xff;
        if (x < 0)
        {
            if (width == 32)
                mask >>= ((6-x) >> 2);
            else
                mask >>= ((6-x) >> 1);
        }
        else if (x + width > 160)
        {
            if (width == 32)
                mask <<= ((x-128) >> 2);
            else
                mask <<= ((x-144) >> 1);
        }
        if (mask != 0xff)
        {
            hmove = 0;
            for (i = (y + position); i < (y + height) && i < 160;i++)
                hmove += (playerstream[i] &= mask);



            if (hmove == 0)
                return 1;
        }
    }


    if (imageID <= 1)
    {
        my_memcpy(hmpstream + y,
                  (unsigned char *)flashdata + gImageShift[imageID] + offset,
                  height);
        x += hmpstream[y] & 0x07;
        hmpstream[y] = 8;
    }
    else
    {
        my_memset(hmpstream + y, 8, height);
    }


    if (size) x--;

    if (position)
    {
        x++;

        if (x <= 4)
            x += 160;

  hmove = 0;
  while (x > 15)
  {
   x -= 15;
   hmove++;
  }
  if (hmove > 10) hmove = 0;

        if ((hmove == 0) && (x >= 5))
            x -= 5;

  x ^= 7;
  x <<= 4;

        gJumpDataStream[y + position] = resptable[hmove];
        hmpstream[y + position] = 8;
        hmpstream[y + position + 1] = x | 8;
        gSizeBallColorDataStream[y + position + 1] = size;
        gColorHMDataStream[y + position + 1] = gSpriteColor[index] + lumaboost;
    }
    else
    {
        if (x < 0) x += 160;
        ((unsigned char *)(0x40000C00 + 2686 ))[1-stream] = x;
        ((unsigned char *)(0x40000C00 + 2688 ))[stream] = size;
        ((unsigned char *)(0x40000C00 + 2690 ))[stream] = gSpriteColor[index] + lumaboost;
    }

    return 1;
}



int DataStreamShot(int stream, int index, int firstcall)
{


    static int y;
    static int height;
    static int offset;
    static int size;

    int hmove;
    int position;
    int x;
    unsigned short int * resptable;
    int missile_on;
    int shape;


    if (firstcall)
    {
        y = gShotY[index];







        if (index == 20) shape = gShotState[20];
        else shape = gShotState[index] & 3;

        height = shot_height[shape];
        size = shot_size[shape];

        if (y < 0)
        {
            if (-y >= height)
                return 1;
            offset = -y;
            height -= offset;
            y = 0;
        }
        else
            offset = 0;

        if (y+height >= 160)
            height = 160 - y;
    }
    if (stream == 0)
    {

        missile_on = 0x04;
        resptable = ((unsigned short int *)(0x0C00 + 18476 ));
    }
    else
    {

        missile_on = 0x08;
        resptable = ((unsigned short int *)(0x0C00 + 18498 ));
    }

    if (y < 4)
    {


        if (((unsigned char *)(0x40000C00 + 2684 ))[1-stream] != 0xff)
            return 0;
        position = 0;
    }
    else
    {

        if (gJumpDataStream[y-1] == 61896) position = -1;
        else if (gJumpDataStream[y-2] == 61896) position = -2;
        else if (gJumpDataStream[y-3] == 61896) position = -3;
        else if (gJumpDataStream[y-4] == 61896) position = -4;
        else return 0;
    }


    for (x = (y + position); x < (y + height) && x < 160;x++)
    {
        if (((unsigned char *)(0x40000C00 + 1484 ))[x] & missile_on)
            return 0;
    }


    for (x=y; x<(y+height) ;x++)
        gMissileBallDataStream[x] |= missile_on;


    for (x=y+position;x<(y+height) ;x++)
        ((unsigned char *)(0x40000C00 + 1484 ))[x] |= missile_on;

    x = gShotX[index] + 1;

    if (position)
    {
        x++;

        if (x <= 4)
            x += 160;

  hmove = 0;
  while (x > 15)
  {
   x -= 15;
   hmove++;
  }
  if (hmove > 10) hmove = 0;

        if ((hmove == 0) && (x >= 5))
            x -= 5;

  x ^= 7;
  x <<= 4;

        gJumpDataStream[y + position] = resptable[hmove];
        gColorHMDataStream[y + position +1] = x;
        gSizeBallColorDataStream[y + position + 1] = size;
    }
    else
    {
        ((unsigned char *)(0x40000C00 + 2684 ))[1-stream] = x;
        ((unsigned char *)(0x40000C00 + 2688 ))[stream] |= size;
    }

    return 1;
}


void DisplayStars()
{
    int i;
    int x;
    int y;
    int hmove;
    int blink;

    y = gStarfieldYoffset >> 2;
    blink = (((*(unsigned char *)(0x40000C00 + 2693 )) >> 5) + gStarfieldTopStar) & 7;
    i = gStarfieldTopStar;

    while (y < 160 - 1)
    {
        if (blink && (gJumpDataStream[y] == 61896))
        {
            x = ((unsigned char *)(0x40000C00 + 2299 ))[i] + (gStarfieldXoffset >> 2);
            if (x > 159) x-= 160;
            if (x <= 4)
                x += 160;

            hmove = 0;
            while (x > 15)
            {
                x -= 15;
                hmove++;
            }
            if (hmove > 10) hmove = 0;

            if ((hmove == 0) && (x >= 5))
                x -= 5;

            x ^= 7;
            x <<= 4;

            gJumpDataStream[y] = ((unsigned short int *)(0x0C00 + 18520 ))[hmove];
            gColorHMDataStream[y + 1] = x;
            gSizeBallColorDataStream[y + 1] = ((unsigned char *)(0x40000C00 + 2555 ))[i];
            gMissileBallDataStream[y+1] |= 2;
        }
        y += ((unsigned char *)(0x40000C00 + 2427 ))[i];
        blink++;
        blink &= 7;

        i++;
        i &= 127;
    }
}

const unsigned char joystick_direction[] = { 9, 9, 9, 9, 9, 3, 1, 2, 9, 5, 7, 6, 9, 4, 0, 9};




const signed char joy_dir_x[] = { 0, 1, 1, 1, 0,-1,-1,-1 };
const signed char joy_dir_y[] = {-1,-1, 0, 1, 1, 1, 0,-1 };
const unsigned char ship_x_adj[] = { 0, 1, 1, 1, 0, 0, 0, 0 };

const unsigned char shot_shape[] = { 2, 1, 0, 1};

const signed char shot_offset_x[] = { 4, 6, 4, 6, 4, 0, 0,-1};
const signed char shot_offset_y[] = {-3, 4, 7, 11, 14, 11, 7, 3};

void ProcessJoystick()
{
    int i;
    int x;
    int y;
    int free_shot[2];

    int direction;
# 1365 "main.c"
    if ((*(unsigned char *)(0x40000C00 + 2701 )) & 0x80)
            return;

    x = y = 0;

    direction = joystick_direction[(*(unsigned char *)(0x40000C00 + 2700 )) >> 4];

    if ((gSpriteState[8] & 0xC0) == 0x80)
    {
        if (direction < 8)
            gShipDir = direction;
        gSpriteImageID[8] = 10 + gShipDir;
    }
    else
    {

        (*(unsigned char *)(0x40000C00 + 2702 )) = 0xff;
    }

    x = joy_dir_x[gShipDir];
    y = joy_dir_y[gShipDir];
    gWindowX += x << 7;
    gWindowY += y << 6;
    gSpriteX[8] = gWindowX + ((80 + ship_x_adj[gShipDir]) << 7);
    gSpriteY[8] = gWindowY + ((((160 - 16) /2) ) << 6);


    for (i=4;i<20;i++)
    {
        if (gShotState[i])
        {
            gShotX[i] -= x;
            gShotY[i] -= y;
        }
    }


    gStarfieldXoffset -= x;
    gStarfieldYoffset -= y;

    if (gStarfieldXoffset < 0 ) gStarfieldXoffset = 159 << 2;
    if (gStarfieldXoffset >> 2 == 160 ) gStarfieldXoffset = 0;

    if (y > 0)
    {
        if (gStarfieldYoffset < 0)
        {
            gStarfieldYoffset = ((unsigned char *)(0x40000C00 + 2427 ))[gStarfieldTopStar] << 2;
            gStarfieldTopStar++;
            gStarfieldTopStar &= 127;
        }
    }
    else
    {
        if (gStarfieldYoffset >> 2 == ((unsigned char *)(0x40000C00 + 2427 ))[(gStarfieldTopStar - 1) & 127])
        {
            gStarfieldYoffset = 0;
            gStarfieldTopStar--;
            gStarfieldTopStar &= 127;
        }
    }



    if (gGunCoolDown) gGunCoolDown--;
    if (!((*(unsigned char *)(0x40000C00 + 2702 )) & 0x80))
    {
        x = 0;
        for (i=0;i<4 && x < 2;i++)
        {
            if (gShotState[i] == 0)
            {
                free_shot[x] = i;
                x++;
            }
        }

        if (x == 2 && gGunCoolDown == 0)
        {
            TriggerSoundEffect(13);
            gGunCoolDown = 15;
            for (i=0;i<2;i++)
            {
                x = free_shot[i];
                gShotState[x] = 0x80 + (((gShipDir + i*4) & 7) << 2)+ shot_shape[gShipDir & 3];
                gShotX[x] = ((gSpriteX[8] - gWindowX) >> 7) + shot_offset_x[(gShipDir + i * 4) & 7];
                gShotY[x] = ((gSpriteY[8] - gWindowY) >> 6) + shot_offset_y[(gShipDir + i * 4) & 7];
            }
        }
    }
}

void FixSizes()
{
    int i;
    unsigned char player[2];
    unsigned char missile[2];


    player[0] = (*(unsigned char *)(0x40000C00 + 2688 )) & 7;
    player[1] = (*(unsigned char *)(0x40000C00 + 2689 )) & 7;
    missile[0] = (*(unsigned char *)(0x40000C00 + 2688 )) & 0x30;
    missile[1] = (*(unsigned char *)(0x40000C00 + 2689 )) & 0x30;

    for(i=0;i<160 -1;i++)
    {

        if (gJumpDataStream[i] >= 62278 && gJumpDataStream[i] <= 64184)
        {
            if (gJumpDataStream[i] <= 63208)
            {
                if (gJumpDataStream[i] <= 62721)
                {
                    player[0] = gSizeBallColorDataStream[i+1];
                    gSizeBallColorDataStream[i+1] |= missile[0];
                }
                else
                {
                    player[1] = gSizeBallColorDataStream[i+1];
                    gSizeBallColorDataStream[i+1] |= missile[1];
                }
            }
            else
            {
                if (gJumpDataStream[i] <= 63696)
                {
                    missile[0] = gSizeBallColorDataStream[i+1];
                    gSizeBallColorDataStream[i+1] |= player[0];
                }
                else
                {
                    missile[1] = gSizeBallColorDataStream[i+1];
                    gSizeBallColorDataStream[i+1] |= player[1];
                }
            }
        }
    }
}

const unsigned char digit_stream[] =
{
    80,
    60,
    40,
    40,
    20,
    20,
    100,
};

const unsigned char digit_offset[] =
{
    5,
    4,
    4,
    0,
    1,
    5,
    3
};

const unsigned char digit_flipped[] =
{
    0,
    1,
    1,
    1,
    0,
    0,
    1
};

const unsigned char flip7[] =
{
    0,
    4,
    2,
    6,
    1,
    5,
    3,
    7
};


void ShowDigit(int digit, int position)
{
    unsigned char temp;
    int i;

    for (i=0;i<15;i++)
    {
        temp = ((unsigned char *)(0x0C00 + 18645 ))[(digit * 15) + i];
        if (digit_flipped[position]) temp = flip7[temp];
        temp <<= digit_offset[position];
        gPlayfield[digit_stream[position] + i] |= temp;
    }
}



void PrepScoreRadar()
{
    int i;
    int x;
    int y;
    int score;
    for (i=0;i<20;i++)
    {
        gPlayfield[i + 0] = 0x00;
        gPlayfield[i + 20] = 0x00;
        gPlayfield[i + 40] = 0x00;
        gPlayfield[i + 60] = 0x00;
        gPlayfield[i + 80] = 0x00;
        gPlayfield[i + 100] = 0x00;
        gP0DataStream[160 + 1 + i] = 0;
        gP1DataStream[160 + 1 + i] = 0;
    }

    if ((*(unsigned char *)(0x40000C00 + 2701 )) & 0x40)
    {

        ShowDigit(20, 5);
        ShowDigit((*(unsigned char *)(0x40000C00 + 2703 )) >> 4, 4);
        ShowDigit((*(unsigned char *)(0x40000C00 + 2703 )) & 15, 3);
        ShowDigit(21, 2);
        ShowDigit((*(unsigned char *)(0x40000C00 + 2704 )) >> 4, 1);
        ShowDigit((*(unsigned char *)(0x40000C00 + 2704 )) & 15, 0);
    }
    else
    {
        score = gScore;
        for (i=0;i<6;i++)
        {
            ShowDigit(score & 0x0f, i);
            score >>= 4;
            if (score == 0) break;
        }
    }


    gP0DataStream[160 + 1] = 0xc0;
    gP0DataStream[160 + 2] = 0x80;
    gP1DataStream[160 + 1] = 0x03;
    gP1DataStream[160 + 2] = 0x01;
    gP0DataStream[160 + 19] = 0x80;
    gP0DataStream[160 + 20] = 0xc0;
    gP1DataStream[160 + 19] = 0x01;
    gP1DataStream[160 + 20] = 0x03;


    i = (gReserveLives <= 9) ? gReserveLives : 16;
    ShowDigit(i, 6);



    if ((*(unsigned char *)(0x40000C00 + 2693 )) == 0)
    {
        if (gCondition == 2)
            gCondition = 0;
        else
            gCondition++;
    }


    i = gObjectColors[8 + gCondition];
    if ((gCondition == 2) && ((*(unsigned char *)(0x40000C00 + 2693 )) & 0x10)) i = 0;
    ((unsigned char *)(0x40000C00 + 2284 ))[0] = i;


    for (i=0;i<8;i++)
    {
        if (gSpriteState[i])
        {
            x = gSpriteX[i] >> (7 + 6);
            y = gSpriteY[i] >> (6 + 6);
            gP1DataStream[160 + 3 + y] |= 1 << (7-x);
        }
    }


    if (gSpriteState[9])
    {
        x = gSpriteX[9] >> (7 + 6);
        y = gSpriteY[9] >> (6 + 6);
        gP0DataStream[160 + 3 + y] |= 1 << (7-x);
    }


    if (((*(unsigned char *)(0x40000C00 + 2693 )) & 8) == 8)
    {
        x = -(gSpriteX[8] >> (7 + 6));

        x <<= 4;
        ((unsigned char *)(0x40000C00 + 2284 ))[1] = x;

        y = gSpriteY[8] >> (6 + 6);
        gPlayfield[y + 0] |= 2;
    }
}




void MoveShots()
{
    int i;
    int speed;
    speed = 3;



    for (i=0;i<20;i++)

    {
        if (i == 4) speed = 1;

        if (gShotState[i])
        {
            gShotX[i] += speed*joy_dir_x[(gShotState[i] & 0x1C) >> 2];
            gShotY[i] += speed*joy_dir_y[(gShotState[i] & 0x1C) >> 2];

            if (gShotX[i] < 8 || gShotX[i] >= 160 || gShotY[i] < 0 || gShotY[i] >= 160)
                gShotState[i] = 0;
        }
    }
}

void TriggerSoundEffect(int SoundID)
{
    int channel;

    if (flashdata[27352 + (*(unsigned char *)(0x40000C00 + 2695 ))] == 0) channel = 0;
    else if (flashdata[27352 + (*(unsigned char *)(0x40000C00 + 2696 ))] == 0) channel = 1;
    else if (SoundID > (*(unsigned char *)(0x40000C00 + 2695 ))) channel = 0;
    else if (SoundID > (*(unsigned char *)(0x40000C00 + 2696 ))) channel = 1;
    else return;

    ((unsigned char *)(0x40000C00 + 2695 ))[channel] = SoundID;
    ((unsigned char *)(0x40000C00 + 2697 ))[channel] = flashdata[27293 + SoundID] >> 5;
}

void UpdateSound()
{
    int channel;
    for (channel = 0;channel < 2; channel++)
    {
        ((unsigned char *)(0x40000C00 + 2710 ))[channel] = flashdata[27352 + ((unsigned char *)(0x40000C00 + 2695 ))[channel]];
        ((unsigned char *)(0x40000C00 + 2706 ))[channel] = ((unsigned char *)(0x40000C00 + 2710 ))[channel] >> 4;
        ((unsigned char *)(0x40000C00 + 2708 ))[channel] = flashdata[27293 + ((unsigned char *)(0x40000C00 + 2695 ))[channel]];

        if (((unsigned char *)(0x40000C00 + 2710 ))[channel])
        {
            if (((unsigned char *)(0x40000C00 + 2697 ))[channel])
            {
                ((unsigned char *)(0x40000C00 + 2697 ))[channel]--;
            }
            else
            {
                ((unsigned char *)(0x40000C00 + 2695 ))[channel]--;
                ((unsigned char *)(0x40000C00 + 2697 ))[channel] = flashdata[27293 + ((unsigned char *)(0x40000C00 + 2695 ))[channel]] >> 5;
            }
        }


    }
}


void ProcessMenuJoystick()
{
    if (!((*(unsigned char *)(0x40000C00 + 2702 )) & 0x80))
 {
        (*(unsigned char *)(0x40000C00 + 2713 )) = 1;
 }
 else
 {
  if ((*(unsigned char *)(0x40000C00 + 2713 )))
  {
   (*(unsigned char *)(0x40000C00 + 2713 )) = 0;
   if ((*(unsigned char *)(0x40000C00 + 2714 )) == 2)
                NewGame();
  }
 }


 if ((((*(unsigned char *)(0x40000C00 + 2700 )) & 0xF0) == 0xF0) && (!(*(unsigned char *)(0x40000C00 + 2713 ))))
 {
  (*(unsigned char *)(0x40000C00 + 2712 )) = 0;
 }
 else
 {
  (*(unsigned char *)(0x40000C00 + 2712 ))++;
  if ((*(unsigned char *)(0x40000C00 + 2712 )) == 16)
   (*(unsigned char *)(0x40000C00 + 2712 )) = 0;
 }
 if ((*(unsigned char *)(0x40000C00 + 2712 )) == 1)
 {
  if (!((*(unsigned char *)(0x40000C00 + 2700 )) & 0x10) && (!(*(unsigned char *)(0x40000C00 + 2713 ))))
  {
            if ((*(unsigned char *)(0x40000C00 + 2714 )) == 0)
                (*(unsigned char *)(0x40000C00 + 2714 )) = 2;
            else
                (*(unsigned char *)(0x40000C00 + 2714 ))--;

            return;
  }
        if (!((*(unsigned char *)(0x40000C00 + 2700 )) & 0x20) && (!(*(unsigned char *)(0x40000C00 + 2713 ))))
  {
            if ((*(unsigned char *)(0x40000C00 + 2714 )) == 2)
                (*(unsigned char *)(0x40000C00 + 2714 )) = 0;
            else
                (*(unsigned char *)(0x40000C00 + 2714 ))++;

            return;
  }
        if (!((*(unsigned char *)(0x40000C00 + 2700 )) & 0x40))
  {
            if ((*(unsigned char *)(0x40000C00 + 2714 )) != 2)
                TriggerSoundEffect(58);
   switch ((*(unsigned char *)(0x40000C00 + 2714 )))
   {
                case 0:
                    if ((*(unsigned char *)(0x40000C00 + 2715 )) == 0)
                        (*(unsigned char *)(0x40000C00 + 2715 )) = (sizeof(levels) / sizeof(levels[0]))-1;
                    else
                        (*(unsigned char *)(0x40000C00 + 2715 ))--;
                    break;

                case 1:
                    if ((*(unsigned char *)(0x40000C00 + 2716 )) == 0)
                        (*(unsigned char *)(0x40000C00 + 2716 )) = 2;
                    else
                        (*(unsigned char *)(0x40000C00 + 2716 ))--;
                    break;
            }
        }
        else if (!((*(unsigned char *)(0x40000C00 + 2700 )) & 0x80) || ((*(unsigned char *)(0x40000C00 + 2713 ))))
  {
            if ((*(unsigned char *)(0x40000C00 + 2714 )) != 2)
                TriggerSoundEffect(58);
   switch ((*(unsigned char *)(0x40000C00 + 2714 )))
   {
                case 0:
                    if ((*(unsigned char *)(0x40000C00 + 2715 )) == (sizeof(levels) / sizeof(levels[0]))-1)
                        (*(unsigned char *)(0x40000C00 + 2715 )) = 0;
                    else
                        (*(unsigned char *)(0x40000C00 + 2715 ))++;
                    break;

                case 1:
                    if ((*(unsigned char *)(0x40000C00 + 2716 )) == 2)
                        (*(unsigned char *)(0x40000C00 + 2716 )) = 0;
                    else
                        (*(unsigned char *)(0x40000C00 + 2716 ))++;
                    break;
            }
        }
    }
}

void MoveFormation()
{
    int i;
    int x;
    int y;
    int s;
    if ((*(unsigned char *)(0x40000C00 + 2693 )) & 0x80)
    {
        s = 18;
        x = 0;
        y = -1 << 6;
    }
    else
    {
        s = 18 + 1;
        x = 1 << 7;
        y = 0;
    }

    for (i = 9; i< 9 + gFormationSize; i++)
    {
        gSpriteX[i] += x;
        gSpriteY[i] += y;
        gSpriteImageID[i] = s;
        s += 2;
    }
}

void NextLevel()
{
    if (gLevel == (sizeof(levels) / sizeof(levels[0]))-1)
        gLevel = 0;
    else
        gLevel++;
    gInitLevel=1;
}

const unsigned char pod_off_y[] =
{
    0,
    9,
    40,
    53,
    41,
    9,
    0,
    0,
    17,
    37,
    37,
    17
};


const unsigned char pod_off_mask[] =
{


    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x10, 0x20, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
    0x60, 0xff, 0x60, 0xff, 0xff, 0xff, 0xfc, 0xf8, 0xfc, 0xf8, 0xfc, 0xfc, 0xf8, 0xfc, 0xfc, 0xf8, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
    0xf8, 0xfc, 0xf8, 0xf8, 0xfc, 0xf8, 0xfc, 0xfc, 0xf8, 0xfc, 0xf8, 0xff, 0xff, 0xf0, 0xff, 0xf0, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
    0x20, 0x10, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
    0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0xff, 0xff, 0xff, 0x3f, 0x3f, 0x3f, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
    0x3f, 0xff, 0x3f, 0xff, 0xff, 0xff, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x2f, 0x0f, 0x4f, 0xff, 0xff, 0xff, 0xff, 0x0f, 0xff, 0x0f, 0xFF, 0xFF, 0xFF,
    0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf8, 0xff, 0xf4, 0xff, 0xff, 0xff, 0xff, 0xf0, 0xff, 0xf0, 0xFF, 0xFF, 0xFF,
    0xf0, 0xff, 0xf0, 0xff, 0xf0, 0xff, 0xfc, 0xfe, 0xfe, 0xfe, 0xfc, 0xfe, 0xfc, 0xfc, 0xfe, 0xfc, 0xfe, 0xff, 0xff, 0xff, 0xf0, 0xff, 0xf0,
    0xf0, 0xff, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xf4, 0xf8, 0xf8, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xFF, 0xFF, 0xFF,
    0x0f, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x4f, 0x3f, 0x3f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0xFF, 0xFF, 0xFF,

    0x0f, 0xff, 0x0f, 0xff, 0x7f, 0xff,
    0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f,
    0x1f, 0x7f, 0x7f, 0x7f, 0x7f, 0xff,
    0xff, 0xff, 0x0f, 0xff, 0x0f
};

const unsigned char pod_on_y[] =
{
    0,
    0,
    0,
    0,
    0,
    0,
    11,
    0,
    0,
    0,
    0,
    0
};


const unsigned char pod_on_mask[] =
{


    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x20,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00
};


void PodHit(int station, int pod)
{
    int i;
    int y;







    if (pod < 0 || pod >= 6)
        return;

    pod += gSpriteImageID[station] * 6;

    station *= 65;


    y =pod_off_y[pod];
    for (i=0;i<23 && y+i < 65;i++)
        gStationImages[station + i + y] &= pod_off_mask[i + pod * 23];


    y =pod_on_y[pod];
    for (i=0;i<1 && y+i < 65;i++)
        gStationImages[station + i + y] |= pod_on_mask[i + pod * 1];

}

const unsigned char energy_offset[] = { 28, 21};
const unsigned char energy_size[] = { 9, 15};
const unsigned char energy_mask[] = {0xCF, 0xE7};

void OpenStation(int station, int amount)
{
    int i;
    int offset;
    int size;
    int mask;

    offset = energy_offset[gSpriteImageID[station]] + station * 65;
    size = energy_size[gSpriteImageID[station]];
    mask = energy_mask[gSpriteImageID[station]];
    if (amount < size)
        gStationState[station] &= (0xFF - 0x40);
    else
        gStationState[station] |= 0x40;

    for(i=0;i<size && i < amount;i++)
        gStationImages[offset + i] &= mask;
}

void PrepStationGraphics()
{
    static int open = 1;
    static int amount = 0;

    int i;
    int j;
    int count;


    if (((*(unsigned char *)(0x40000C00 + 2693 )) & 31) == 0)
    {
        if (open)
        {
            if (amount < 16)
                amount++;
            else
                open = 0;
        }
        else
        {
            if (amount)
                amount--;
            else
                open = 1;
        }
    }

    count = 0;
    for (i=0;i<8;i++)
    {
        if (gSpriteState[i])
        {
            count++;

            my_memcpy((unsigned char *)queue + 1764 + i*65,
                      (unsigned char *)flashdata + gImageGraphics[gSpriteImageID[i]],
                      gImageHeight[gSpriteImageID[i]]);


            OpenStation(i, amount);

            for (j=0;j<6;j++)
            {
                if ((gStationState[i] & (1 << j)) == 0)
                    PodHit(i, j);
            }
        }
    }
    if (count == 0)
        NextLevel();
}

void StationShots()
{
    int i;
    int f;
    int s;

    s = -1;
    for (i=0;i<8;i++)
    {
        if (gSpriteState[i] & 15)
            gSpriteState[i]--;
        else if ((gSpriteState[i] & 0x5f) == 0x40)
            s = i;
    }

    f = 0;



    for (i=4;i<20;i++)

        if (gShotState[i] == 0)
            f = i;

    if (f && s != -1)
    {
        gSpriteState[s] |= 15;
        gShotState[f] = 0x80 + ((Random32() & 7) << 2) + 3;
        gShotX[f] = ((gSpriteX[s] - gWindowX) >> 7) + 16;
        gShotY[f] = ((gSpriteY[s] - gWindowY) >> 6) + 32;
    }
}

unsigned char NTSCtoPAL[16] =
{


    0x00, 0x20, 0x20, 0x40, 0x60, 0x80, 0xa0, 0xc0,
    0xd0, 0xb0, 0x90, 0x70, 0x50, 0x30, 0x30, 0x20
};

int ColorPAL(int color)
{
    return NTSCtoPAL[color>>4] +
    (color & 0x0f);
}


unsigned char NTSCtoSECAM[16] =
{
    0x0e,
    0x0c,
    0x0c,
    0x04,
    0x04,
    0x06,
    0x06,
    0x06,
    0x02,
    0x02,
    0x0a,
    0x0a,
    0x08,
    0x08,
    0x08,
    0x0c
};

int ColorSECAM(int color)
{
    if (color < 2)
        return 0;
    else
        return NTSCtoSECAM[color>>4];
}

int ColorConvert(int color)
{
    if ((*(unsigned char *)(0x40000C00 + 2716 )) == 1)
        return ColorPAL(color);
    else if ((*(unsigned char *)(0x40000C00 + 2716 )) == 2)
        return ColorSECAM(color);
    else
        return color;
}

const unsigned char double_nybble[] = { 0x00, 0x03, 0x0C, 0x0F,
    0x30, 0x33, 0x3C, 0x3F,
    0xC0, 0xC3, 0xCC, 0xCF,
    0xF0, 0xF3, 0xFC, 0xFF};

int DoubleBits(int bits)
{
    return (double_nybble[(bits & 0xf0) >> 4] << 8) + double_nybble[bits & 0x0f];
}

int Collision(int image1_id, int left1, int top1, int sprite_index)
{
# 2150 "main.c"
    int right1;
    int bottom1;

    int left2;
    int top2;
    int right2;
    int bottom2;
    int image2_id;
    int double2;

    int top3;
    int bottom3;

    int j;

    unsigned char * image1;
    unsigned char * image2;

    int y_overlap;
    int x_shift;

    right1 = left1 + 8;
    bottom1 = top1 + gImageHeight[image1_id];

    left2 = gSpriteX[sprite_index] >> 7;
    image2_id = gSpriteImageID[sprite_index];
    if (left2 < right1)
    {
        double2 = (image2_id <= 5) ? 8 : 0;
        right2 = left2 + 8 + double2;
        if (right2 > left1)
        {
            top2 = gSpriteY[sprite_index] >> 6;
            if (top2 < bottom1)
            {
                bottom2 = top2 + gImageHeight[image2_id];
                if (bottom2 > top1)
                {


                    if (top1 > top2)
                    {
                        top3 = top1;
                        image1 = (unsigned char *)flashdata + gImageGraphics[image1_id];
                        image2 = (unsigned char *)flashdata + gImageGraphics[image2_id] + top1 - top2;
                    }
                    else
                    {
                        top3 = top2;
                        image1 = (unsigned char *)flashdata + gImageGraphics[image1_id] + top2 - top1;
                        image2 = (unsigned char *)flashdata + gImageGraphics[image2_id];
                    }

                    bottom3 = (bottom1 < bottom2) ? bottom1 : bottom2;

                    x_shift = left2 - left1;
                    y_overlap = bottom3-top3;

                    if (double2)
                    {
                        if (x_shift < 0)
                        {
                            for(j=0;j<y_overlap;j++)
                                if ((image1[j] << 8) & (DoubleBits(image2[j]) << -x_shift))
                                    return 1;
                        }
                        else
                        {
                            x_shift += 8;
                            for(j=0;j<y_overlap;j++)
                                if ((image1[j] << x_shift) & DoubleBits(image2[j]))
                                    return 1;
                        }
                    }
                    else
                    {
                        if (x_shift < 0)
                        {
                            for(j=0;j<y_overlap;j++)
                                if (image1[j] & (image2[j] << -x_shift))
                                    return 1;
                        }
                        else
                        {
                            for(j=0;j<y_overlap;j++)
                                if ((image1[j] << x_shift) & image2[j])
                                    return 1;
                        }
                    }
                }
            }
        }
    }
    return 0;
}

const unsigned char quad_pair[] = {0, 0x0f, 0xf0, 0xff};

unsigned int QuadBits(int bits, int shift)
{


 return (unsigned int)((quad_pair[bits & 3]) +
                          (quad_pair[(bits >> 2) & 3] << 8) +
                          (quad_pair[(bits >> 4) & 3] << 16) +
                          (quad_pair[(bits >> 6) & 3] << 24)) >> shift;
}


int CollisionQuad(int image1_id, int left1, int top1, int sprite_index)
{
    int right1;
    int bottom1;

    int left2;
    int top2;
    int right2;
    int bottom2;
    int image2_id;

    int top3;
    int bottom3;

    int j;

    unsigned char * image1;
    unsigned char * image2;
    unsigned char * shift;

    int y_overlap;
    int x_shift;

    right1 = left1 + 8;
    bottom1 = top1 + gImageHeight[image1_id];

    left2 = gSpriteX[sprite_index] >> 7;
    image2_id = gSpriteImageID[sprite_index];
    if (left2 < right1)
    {
        right2 = left2 + 32;
        if (right2 > left1)
        {
            top2 = gSpriteY[sprite_index] >> 6;
            if (top2 < bottom1)
            {
                bottom2 = top2 + gImageHeight[image2_id];
                if (bottom2 > top1)
                {


                    if (top1 > top2)
                    {
                        top3 = top1;
                        image1 = (unsigned char *)flashdata + gImageGraphics[image1_id];
                        image2 = (unsigned char *)(unsigned char *)queue + 1764 + sprite_index*65 + top1 - top2;
                        shift = (unsigned char *)flashdata + gImageShift[image2_id] + top1 - top2;
                    }
                    else
                    {
                        top3 = top2;
                        image1 = (unsigned char *)flashdata + gImageGraphics[image1_id] + top2 - top1;
                        image2 = (unsigned char *)queue + 1764 + sprite_index*65;
                        shift = (unsigned char *)flashdata + gImageShift[image2_id];
                    }

                    bottom3 = (bottom1 < bottom2) ? bottom1 : bottom2;

                    x_shift = left2 - left1;
                    y_overlap = bottom3-top3;

                    if (x_shift < 0)
                    {
                        for(j=0;j<y_overlap;j++)
                            if ((image1[j] << 24) & (QuadBits(image2[j], shift[j] & 7) << -x_shift))
                                return 1;
                    }
                    else
                    {
                        x_shift += 24;
                        for(j=0;j<y_overlap;j++)
                            if ((image1[j] << x_shift) & QuadBits(image2[j], shift[j] & 7))
                                return 1;
                    }
                }
            }
        }
    }
    return 0;
}

void ShipCollisions()
{
    int j;
    int x;
    int y;
    int start;
    int end;
    int sprite;

    if ((gSpriteState[8] & 0xC0) == 0x80)
    {
        x = gSpriteX[8] >> 7;
        y = gSpriteY[8] >> 6;
        start = ((y / 32) * 4) + 22;
        end = (((y + gImageHeight[gSpriteImageID[8]]) / 32) * 4) + 22 + 4;




        for (j=0; j<8; j++)
        {
            if (gSpriteState[j] & 0x40)
            {

            }
        }


        for(j=9;j<22;j++)
        {
            if (gSpriteState[j])
            {
                if (Collision(gSpriteImageID[8], x, y, j))
                {
                    InitDeathSequence(8, 0);
                    TriggerSoundEffect(56);
                }
            }
        }


        for (j=start; j<end; j++)
        {
            if (j >= 150)
                sprite = j - (32 * 4);
            else
                sprite = j;
            if (gSpriteState[sprite] && (gSpriteState[sprite] & 0x20) == 0)
            {
                if (Collision(gSpriteImageID[8], x, y, sprite))
                {
                    InitDeathSequence(8,0);
                    TriggerSoundEffect(56);

                    switch (gSpriteImageID[sprite])
                    {
                        case 9:
                            IncreaseScore(0x20);
                            InitDeathSequence(sprite, 0);
                            TriggerSoundEffect(42);
                            break;

                        case 6:
                        case 6 +1:
                        case 6 +2:
                            IncreaseScore(0x10);
                            InitDeathSequence(sprite, 0x20);
                            TriggerSoundEffect(29);
                            break;
                    }
                }
            }
        }
    }
}

void ShotCollisions()
{
    int i;
    int j;
    int k;
    int x;
    int y;
    int start;
    int end;
    int sprite;
    int shot_id;
    int pod;
# 2451 "main.c"
    for (i=0;i<4;i++)
    {
        if (gShotState[i])
        {
            x = (gShotX[i] + (gWindowX >> 7)) & (512 -1);
            y = (gShotY[i] + (gWindowY >> 6)) & (1024 -1);
            shot_id =(gShotState[i] & 3) + 26;
            start = ((y / 32) * 4) + 22;
            end = (((y + shot_height[gShotState[i] & 3]) / 32) * 4) + 22 + 4;


            for (j=0; j<8; j++)
            {
                if (gSpriteState[j] & 0x40)
                {
                    pod = gSpriteImageID[j] * 7;
                    for(k=0;k<7;k++)
                    {
                        if (gStationState[j] & (1 << k))
                        {
                            gSpriteX[150] = gSpriteX[j] + (pod_offset_x[pod+k] << 7);
                            gSpriteY[150] = gSpriteY[j] + (pod_offset_y[pod+k] << 6);
                            gSpriteImageID[150]= pod_shape[pod+k];
                            if (Collision(shot_id, x, y, 150))
                            {
                                if (k < 6)
                                {
                                    gStationState[j] ^= (1 << k);
                                    IncreaseScore(0x50);
                                    TriggerSoundEffect(42);
                                    gShotState[i] = 0;

                                }

                                if (k == 6 || (gStationState[j] & 0x3f) == 0)
                                {
                                    gSpriteState[j] = 0;
                                    IncreaseScore(0x200);
                                    TriggerSoundEffect(42);
                                    gShotState[i] = 0;
                                }
                            }
                        }
                    }
                    if (gShotState[i])
                        if (CollisionQuad(shot_id, x, y, j))
                            gShotState[i] = 0;
                }
            }


            for(j=9;j<22;j++)
            {
                if (gSpriteState[8])
                {

                }
            }


            for (j=start; j<end; j++)
            {
                if (j >= 150)
                    sprite = j - (32 * 4);
                else
                    sprite = j;
                if (gSpriteState[sprite])
                {
                    if (Collision(shot_id, x, y, sprite))
                    {
                        switch (gSpriteImageID[sprite])
                        {
                            case 9:
                                IncreaseScore(0x20);
                                InitDeathSequence(sprite, 0);
                                TriggerSoundEffect(42);
                                gShotState[i] = 0;
                                break;

                            case 6:
                            case 6 +1:
                            case 6 +2:
                                IncreaseScore(0x10);
                                InitDeathSequence(sprite, 0x20);
                                TriggerSoundEffect(29);
                                gShotState[i] = 0;
                                break;
                        }
                    }
                }
            }
        }
    }





    for (i=4;i<20;i++)

    {
        if (gShotState[i])
        {
            if ((gSpriteState[8] & 0xC0) == 0x80)
            {
                x = (gShotX[i] + (gWindowX >> 7)) & (512 -1);
                y = (gShotY[i] + (gWindowY >> 6)) & (1024 -1);


                if (Collision(29, x, y, 8))
                {
                    InitDeathSequence(8, 0);
                    TriggerSoundEffect(56);
                    gShotState[i] = 0;
                }
            }
        }
    }
}


int BCDadd(register int a, register int b)
{

 unsigned int t1, t2, t3, t4, t5, t6;

 t1 = a + 0x06666666;
 t2 = t1 + b;
 t3 = t1 ^ b;
 t4 = t2 ^ t3;
 t5 = ~t4 & 0x11111110;
 t6 = (t5 >> 2) | (t5 >> 3);
 return t2 - t6;
}

void IncreaseScore(int points)
{
    int temp;


    temp = BCDadd(gScore, points);
# 2606 "main.c"
    gScore = temp;
}

void PlayerDecreaseLives()
{
    int i;
    int l;
    const unsigned short int *level;

    if (gReserveLives == 0)
    {

        (*(unsigned char *)(0x40000C00 + 2705 )) = 0;
    }
    else
    {
        gReserveLives--;

        level = levels[gLevel];


        l = 0;
        gSpriteState[8] = 0x80;
        gSpriteImageID[8] = 10;
        gSpriteColor[8] = gObjectColors[2];
        gSpriteX[8] = level[l++] << 7;
        gSpriteY[8] = level[l++] << 6;
        gShipDir = 0;

        gWindowX = gSpriteX[8] - (80 << 7);
        gWindowY = gSpriteY[8] - (((160 - 16) /2) << 6);

        for (i=0;i<20;i++)
            gShotState[i] = 0;
    }
}


void InitDeathSequence(int index, int not_deadly)
{
    int adjust;


    adjust = (21 - gImageHeight[gSpriteImageID[index]]) >> 1;
    if (not_deadly)
    {
        gSpriteState[index] = 0xC0 + (15 >> 1) + 0x20;
        gSpriteColor[index] = 12;
    }
    else
    {
        gSpriteState[index] = 0xC0 + 15;
        gSpriteColor[index] = (*(unsigned char *)(0x40000C00 + 2693 ));
    }
    gSpriteImageID[index] = 2;
    gSpriteX[index] -= 4 << 7;
    gSpriteY[index] -= adjust << 6;
}

void DeathSequences()
{
    int i;
    int time;
    for (i=8; i< 150;i++)
    {

        if ((gSpriteState[i] & 0xC0) == 0xC0)
        {
            if (gSpriteState[i] & 0x20)
            {
                time = (15 >> 1);
            }
            else
            {
                time = 15;
                gSpriteColor[i] = (*(unsigned char *)(0x40000C00 + 2693 ));
            }
            if (gSpriteState[i] & 0x0f)
            {
                gSpriteState[i]--;
            }
            else
            {
                if (gSpriteImageID[i] < 5)
                {
                    gSpriteImageID[i]++;
                    gSpriteState[i] += time;
                }
                else
                {
                    gSpriteState[i] = 0;
                    if (i == 8)
                        PlayerDecreaseLives();
                }
            }
        }
    }
}
